<template>
  <Loading v-if="$fetchState.pending && !$fetchState.error"></Loading>
  <Error v-else-if="$fetchState.error" :error="$fetchState.error"></Error>
  <div v-else>
    <ExploreBoard v-if="projects.length" pretitle="explore" title="projects">
      <template #header-right>
        <div class="btn-list justify-content-end">
          <div class="d-none d-sm-inline">
            <a
              class="btn mr-1m rimow-step-by-step-guide mode-simple toggle-mode-visible visible cursor-pointer"
              @click="initIntro()"
            >
              <DirectionsIcon />
              Step-by-step guide
            </a>
          </div>
          <a
            v-b-modal.modal-create-project
            data-intro="Start by clicking here to create a new project!"
            href="#"
            class="btn btn-primary project-new d-none d-sm-inline-block"
          >
            <FolderPlusIcon />
            Start a new project
          </a>
        </div>
      </template>
      <template #panel-left>
        <div class="nav-search-explore">
          <div class="mb-3">
            <div class="nav-search-explore-form">
              <ExploreSearchBox
                placeholder="Search in projects..."
                item-type="projects"
                :first="search.meta.first"
                :last="search.meta.last"
                :total="projects.length"
                @search="setSearchValue"
              >
              </ExploreSearchBox>
            </div>
          </div>
          <ExploreSearchFilters
            :search-fields="searchFilter.fields"
            :sort-fields="searchFilter.sort"
            :defaults="searchFilter.defaults"
            direction="Descending"
            @filtersChanged="filtersChanged"
          />
        </div>
      </template>
      <template #main-content>
        <div
          v-if="filteredProjects.length"
          class="rimow-card-deck row row-deck results-found"
        >
          <div
            v-for="project in filteredProjects"
            :key="project.index"
            class="rimow-card card-prj col-sm-6 col-lg-4 mb-2"
          >
            <ProjectCard :project="project" />
          </div>
        </div>
        <EmptyData
          v-else
          title="No projects found"
          description="No projects found for your search"
          image="/illustrations/empty-project-board.svg"
        >
        </EmptyData>
      </template>
    </ExploreBoard>
    <EmptyData
      v-else
      title="You don't have any projects yet"
      description="Try creating a new one"
      image="/illustrations/no-projects-yet.svg"
    >
      <template #primary-button>
        <a
          v-b-modal.modal-create-project
          href="#"
          class="btn btn-primary project-new d-none d-sm-inline-block mb-5"
        >
          <FolderPlusIcon />
          Start a new project
        </a>
      </template>
    </EmptyData>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
import searchFilterMixin from '~/mixins/search-filter.js';
export default {
  mixins: [searchFilterMixin],
  layout: 'dashboard',
  middleware: 'auth',
  data() {
    return {
      filteredProjects: [],
      filters: {
        filterBy: [{ filterBy: 'title' }],
        orderBy: 'creation_datetime',
        direction: 'Descending',
      },
      valueToSearch: '',
      search: {
        meta: {
          first: 1,
          last: 0,
        },
      },
    };
  },
  async fetch() {
    await this.$nuxt.context.store.dispatch('projects/fetchProjects');
    this.filtersChanged(this.filters);
  },
  head() {
    return {
      title: 'Projects - RISIS Workspace',
    };
  },
  computed: {
    ...mapGetters({
      projects: 'projects/allProjects',
    }),
    searchFilter() {
      return {
        fields: [
          {
            text: 'Title',
            filterBy: 'title',
          },
          {
            text: 'Status',
            filterBy: 'status.title',
          },
          {
            text: 'Author',
            filterBy: 'author.first_name',
          },
          {
            text: 'Description',
            filterBy: 'short_description',
          },
        ],
        sort: [
          {
            text: 'Date',
            filterBy: 'creation_datetime',
          },
          {
            text: 'Name',
            filterBy: 'title',
          },
          {
            text: 'Author',
            filterBy: 'author.first_name',
          },
          {
            text: 'Status',
            filterBy: 'status.title',
          },
        ],
      };
    },
  },
  watch: {
    projects() {
      this.filtersChanged(this.filters);
    },
  },
  methods: {
    setSearchValue(valueToSearch) {
      this.valueToSearch = valueToSearch;
      this.filtersChanged(this.filters);
    },
    filtersChanged(filters) {
      this.filters = filters;
      this.filteredProjects = this.searchFunction(
        this.valueToSearch,
        this.projects,
        this.filters
      );
      this.filteredProjects = this.applyFilter(
        this.filters,
        this.filteredProjects
      );
      this.search.meta.last = this.filteredProjects.length;
    },
    initIntro() {
      this.$store.commit('ui/showIntroJs');
    },
  },
};
</script>
